.386
.model flat,stdcall
option casemap:none

include filefunc.inc

PUBLIC  ReadFileToMem@12

.code

;   ReadFileToMem PROC pFileName:DWORD,pMem:DWORD,pNumbOfBytesRead:DWORD

;   pFileName           :  pointer to name of the file
;   pMem                :  pointer to the memory block allocated to read the input file
;   pNumbOfBytesRead    :  pointer receiving the number of bytes read

;   Return value        :  if the function succeeds, the return value is 2
;                          if the function fails, the return value is 1,0 or -1
;                          depending on the situation  


ReadFileToMem@12:

    sub     esp,2*4                                                     ; reserve 12 bytes for local variables
    push    edi
    
    invoke  CreateFile,DWORD PTR [esp+40],GENERIC_READ,0,0,\
            OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0                      ; open file
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit
@@:
    mov     DWORD PTR [esp+8],eax                                       ; save the file handle
    invoke  GetFileSize,eax,0
    lea     edx,DWORD PTR [esp+4]
    invoke  ReadFile,DWORD PTR [esp+24],DWORD PTR [esp+32],eax,edx,0    ; read file
    test    eax,eax
    jz      _exit
@@:
    push    DWORD PTR [esp+4]
    pop     DWORD PTR [esp+24]                                          ; receive the number of bytes read

    invoke  CloseHandle,DWORD PTR [esp+8]                               ; close file
    test    eax,eax
    jnz     @f
    mov     eax,CLOSE_HANDLE_ERROR
    jmp     _exit
@@:
    mov     eax,READ_FILE_SUCCESS   

_exit:

    pop     edi
    add     esp,2*4                                                     ; balance the stack manually
    ret     3*4                                                         ; release the three parameters and return back    
                                                                        ; to the main module
;   ENDP ReadFileToMem

END

